function copyToClipboard() {
  const url = document.getElementById('generated-url').textContent;
  navigator.clipboard.writeText(url);
  if (Notification.permission === 'granted') {
    new Notification('URL copied!', { body: 'The URL was successfully copied!' });
  } else if (Notification.permission !== 'denied') {
    Notification.requestPermission().then(permission => {
      if (permission === 'granted') {
        new Notification('URL copied!', { body: 'The URL was successfully copied!' });
      }
    });
  }
}

const baseUrl = window.location.href.replace(/#.*|&[^=]*=|^.*?\/index\.html/, '').replace('generator.html', 'index.html');
let paramsObject = {};

function initialGeneratedUrl() {
  const url = window.location.href.replace(/#.*|&[^=]*=|^.*?\/index\.html/, '').replace('generator.html', 'index.html');
  document.getElementById('generated-url').innerHTML = url;
}

// Build the URL parameters
const defaultUrlParamValues = {
  host: '127.0.0.1',
  port: '8080',
  scrollingSpeedPercent: '100',
  iterations: '0',
  removeBroadcaster: true,
  testCredits: false,
  introImageFirst: false,
  outroImageFirst: false,
  introImageUrl: '',
  introText: '',
  outroImageUrl: '',
  outroText: '',
  creditsDuration: '-1',
  pixelSpeed: '0.06'
};

// Update the generated URL container with the new URL
initialGeneratedUrl();

const form = document.getElementById('url-form');

form.addEventListener('change', (event) => {
  let updatedBaseUrl;

  const { target } = event;
  const key = target.name;

  let value = null;
  let paramsObjectKey = '';

  if (!target.disabled && target.type !== 'checkbox') {
    value = target.value;
    paramsObjectKey = key;
  } else if (!target.disabled) {
    value = target.checked;
    paramsObjectKey = key;
  }

  if ((value === defaultUrlParamValues[key]) || (typeof value === 'number' && value === Number(defaultUrlParamValues[key]))) {
    delete paramsObject[paramsObjectKey];
    let params = '';
    Object.keys(paramsObject).forEach((key) => {
      const v = paramsObject[key];
      if (v !== null && v !== '') {
        if (params.length > 0) {
          params += '&';
        }
        params += `${key}=${v}`;
      }
    });

    let paramStr = '';
    if (params.length > 0) {
      paramStr = `?${params}`;
    } else {
      paramStr = '';
    }

    updatedBaseUrl = baseUrl + paramStr;

  } else if (!target.disabled && target.type !== 'checkbox') {
    let updatedValue;
    if (key === 'host') {
      // Remove any special characters except alphanumeric and hyphen
      updatedValue = target.value;
    } else {
      updatedValue = value;
    }

    paramsObject[paramsObjectKey] = updatedValue;

    let params = '';
    Object.keys(paramsObject).forEach((key) => {
      const v = paramsObject[key];
      if (v !== null && v !== '') {
        if (params.length > 0) {
          params += '&';
        }
        params += `${key}=${v}`;
      }
    });

    let paramStr = '';
    if (params.length > 0) {
      paramStr = `?${params}`;
    } else {
      paramStr = '';
    }

    updatedBaseUrl = baseUrl + paramStr;

  } else if (!target.disabled) {
    let updatedValue;
    if (key === 'host') {
      // Remove any special characters except alphanumeric and hyphen
      updatedValue = target.value;
    } else {
      updatedValue = value;
    }

    paramsObject[paramsObjectKey] = updatedValue;

    let params = '';
    Object.keys(paramsObject).forEach((key) => {
      const v = paramsObject[key];
      if (v !== null && v !== '') {
        if (params.length > 0) {
          params += '&';
        }
        params += `${key}=${v}`;
      }
    });

    let paramStr = '';
    if (params.length > 0) {
      paramStr = `?${params}`;
    } else {
      paramStr = '';
    }

    updatedBaseUrl = baseUrl + paramStr;
  }

  document.getElementById('generated-url').innerHTML = updatedBaseUrl;

});
